// ignore_for_file: invalid_annotation_target

import 'package:freezed_annotation/freezed_annotation.dart';

part 'vulnerability.freezed.dart';
part 'vulnerability.g.dart';

/// @nodoc
@internal
@freezed
class Vulnerability with _$Vulnerability {
  /// @nodoc
  @Assert(
    "schemaVersion == '1.3.0'",
    'Only schema version 1.3.0 is supported.',
  )
  const factory Vulnerability({
    @JsonKey(name: 'schema_version') required String schemaVersion,
    required String id,
    required String summary,
  }) = _Vulnerability;

  /// @nodoc
  factory Vulnerability.fromJson(Map<String, dynamic> json) =>
      _$VulnerabilityFromJson(json);
}
